import { __assign, __rest } from "tslib";
import React, { useContext } from "react";
import classNames from "classnames";
import RowContext from "./RowContext";
import { responsiveArray } from "./Row";
export function Col(props) {
    var _a;
    var className = props.className, span = props.span, pull = props.pull, push = props.push, offset = props.offset, order = props.order, children = props.children, others = __rest(props, ["className", "span", "pull", "push", "offset", "order", "children"]);
    var context = useContext(RowContext);
    var prefixCls = "ant-col";
    var sizeClassObj = {};
    responsiveArray.forEach(function (size) {
        var _a;
        var sizeProps = {};
        if (typeof props[size] === "number") {
            sizeProps.span = props[size];
        }
        else if (typeof props[size] === "object") {
            sizeProps = props[size] || {};
        }
        delete others[size];
        sizeClassObj = __assign(__assign({}, sizeClassObj), (_a = {}, _a[prefixCls + "-" + size + "-" + sizeProps.span] = sizeProps.span !== undefined, _a[prefixCls + "-" + size + "-order-" + sizeProps.order] = sizeProps.order || sizeProps.order === 0, _a[prefixCls + "-" + size + "-offset-" + sizeProps.offset] = sizeProps.offset || sizeProps.offset === 0, _a[prefixCls + "-" + size + "-push-" + sizeProps.push] = sizeProps.push || sizeProps.push === 0, _a[prefixCls + "-" + size + "-pull-" + sizeProps.pull] = sizeProps.pull || sizeProps.pull === 0, _a));
    });
    var classString = classNames(prefixCls, className, (_a = {},
        _a[prefixCls + "-" + span] = span !== undefined,
        _a[prefixCls + "-order-" + order] = order,
        _a[prefixCls + "-offset-" + offset] = offset,
        _a[prefixCls + "-push-" + push] = push,
        _a[prefixCls + "-pull-" + pull] = pull,
        _a), sizeClassObj);
    var style = context && context.gutter ? { paddingLeft: context.gutter / 2, paddingRight: context.gutter / 2 } : props.style;
    return (React.createElement("div", { className: classString, style: style }, children));
}
export default React.memo(Col);
//# sourceMappingURL=Col.js.map